#leaving game logic
execute as @a[scores={leave=1}] run scoreboard players reset @s join
execute as @a[scores={leave=1}] run scoreboard players reset @s leave
execute as @a unless entity @s[scores={join=2}] run tag @s add joined
execute as @a unless entity @s[scores={join=2}] run scoreboard players set @s join 2
execute as @a[tag=joined] run function skyscapers:join

#calling functions to loop
function skyscapers:lobby/credits/_tick
function skyscapers:lobby/display/_tick
function skyscapers:lobby/leaderboards/_tick
function skyscapers:hats/_tick
function skyscapers:particles/_tick
function skyscapers:lobby/settings/_tick

#call the gamemodes
execute if entity @e[name=Global,scores={gameState=0}] run function skyscapers:lobby/_tick
execute if entity @e[name=Global,scores={gameState=1}] run function skyscapers:gamemodes/_tick
execute if entity @e[name=Global,scores={gameState=2}] run function skyscapers:gamemodes/classic/_tick
execute if entity @e[name=Global,scores={gameState=3}] run function skyscapers:gamemodes/targets/_tick
execute if entity @e[name=Global,scores={gameState=4}] run function skyscapers:gamemodes/snipers/_tick
execute if entity @e[name=Global,scores={gameState=5}] run function skyscapers:gamemodes/_end

#call wands
function skyscapers:beam_functions/_tick

#cleanup items
kill @e[type=item]
execute if entity @e[type=slime] run kill @e[type=slime,tag=!pslime,tag=!target_slime]

#add scores to random (for powerup use)
scoreboard players add @r random 1
scoreboard players add @e[type=armor_stand,tag=lobby_stand,sort=random,limit=1] random 1
execute if entity @e[scores={random=10000..}] as @e[scores={random=10000..}] run scoreboard players reset @s random
