#timer for pre-game
scoreboard players add @e[name=Global] pregame 1

#clear lobby effects
execute if entity @e[name=Global,scores={pregame=1}] run effect clear @a
execute if entity @e[name=Global,scores={pregame=1}] run effect give @a saturation 100000 255 true
execute if entity @e[name=Global,scores={pregame=1}] if entity @a[scores={timer_bounds=0..}] run scoreboard players reset @a timer_bounds
execute if entity @e[name=Global,scores={pregame=1}] if entity @a[scores={timer_bounds2=0..}] run scoreboard players reset @a timer_bounds2

#reset players in target practice
execute if entity @e[name=Global,scores={pregame=1}] run scoreboard players reset @a[scores={practice_join=1..}] practice_join
execute if entity @e[name=Global,scores={pregame=1}] if entity @a[tag=p] run kill @e[type=slime,tag=pslime]
execute if entity @e[name=Global,scores={pregame=1}] run tag @a[tag=p] remove p

#hide armor stand names
execute if entity @e[name=Global,scores={pregame=1}] as @e[tag=lobby_stand] run data merge entity @s {CustomNameVisible:0b}

#reset start tag
execute if entity @e[name=Global,scores={pregame=1}] run tag @e[name=Global] remove start_game
execute if entity @e[name=Global,scores={pregame=1}] run bossbar set minecraft:readytimer visible false

#reset powerups book
execute if entity @a[tag=has_book] run tag @a remove has_book
clear @a written_book

#in case of failed join refresh
execute if entity @e[name=Global,scores={pregame=1}] as @a run attribute @s minecraft:generic.max_health base set 18

#put people on teams that are not already
execute if entity @e[name=Global,scores={pregame=1},tag=classic] unless entity @a[team=seeker] run team join seeker @a[sort=random,limit=1,team=!spectator]
execute unless entity @a[tag=admin] if entity @e[name=Global,scores={pregame=1},tag=classic] run tag @a[team=seeker,sort=random,limit=1] add chosen
execute unless entity @a[tag=admin] if entity @e[name=Global,scores={pregame=1},tag=classic] run team leave @a[team=!scapers,team=!spectator,tag=!chosen]
execute unless entity @a[tag=admin] if entity @e[name=Global,scores={pregame=1},tag=classic] run team join scapers @a[team=!spectator,team=!seeker]
execute unless entity @a[tag=admin] if entity @e[name=Global,scores={pregame=1},tag=classic] run tag @a[tag=chosen] remove chosen

execute if entity @a[tag=admin,team=seeker] if entity @e[name=Global,scores={pregame=1},tag=classic] run tag @a[team=seeker,tag=admin,sort=random,limit=1] add chosen
execute if entity @a[tag=admin,team=seeker] if entity @e[name=Global,scores={pregame=1},tag=classic] run team leave @a[team=!scapers,team=!spectator,tag=!chosen]
execute if entity @a[tag=admin,team=seeker] if entity @e[name=Global,scores={pregame=1},tag=classic] run team join scapers @a[team=!spectator,team=!seeker]
execute if entity @a[tag=admin,team=seeker] if entity @e[name=Global,scores={pregame=1},tag=classic] run tag @a[tag=chosen] remove chosen

execute if entity @e[name=Global,scores={pregame=1},tag=target] run team join seeker @a[team=!spectator]
execute if entity @e[name=Global,scores={pregame=1},tag=snipers] run team join scapers @a[team=!spectator]

#tp back players outside boundary
#execute if entity @e[name=Global,scores={pregame=1}] as @e[type=armor_stand,name=Global] at @s as @e[type=player,gamemode=adventure,distance=51..] run tp @s -258 86 583

#add a total counts for scapers pregame
execute if entity @e[name=Global,scores={pregame=1}] as @a[team=scapers] run scoreboard players add @e[name=Global] startScapers 1

#initialize the game
execute if entity @e[name=Global,scores={pregame=1}] run effect give @a[team=!spectator] blindness 100000 255 true
execute if entity @e[name=Global,scores={pregame=1}] run effect give @a[team=!spectator] slowness 100000 255 true
execute if entity @e[name=Global,scores={pregame=1}] run effect give @a[team=!spectator] jump_boost 100000 200 true
execute if entity @e[name=Global,scores={pregame=10}] as @a[team=seeker] at @s run particle minecraft:falling_dust minecraft:redstone_block ~ ~2 ~ 0.3 0.3 0.3 1 100 normal @a
execute if entity @e[name=Global,scores={pregame=10}] as @a[team=scapers] at @s run particle minecraft:falling_dust minecraft:light_blue_wool ~ ~2 ~ 0.3 0.3 0.3 1 100 normal @a
execute if entity @e[name=Global,scores={pregame=1}] run clear @a[gamemode=adventure]
execute if entity @e[name=Global,scores={pregame=100},tag=classic] run setblock -221 4 570 redstone_block
execute if entity @e[name=Global,scores={pregame=120},tag=classic] run setblock -221 4 570 stone
execute if entity @e[name=Global,scores={pregame=120},tag=classic] run data merge block -221 5 570 {showboundingbox:0b}
execute if entity @e[name=Global,scores={pregame=100},tag=target] run setblock -221 4 570 redstone_block
execute if entity @e[name=Global,scores={pregame=120},tag=target] run setblock -221 4 570 stone
execute if entity @e[name=Global,scores={pregame=120},tag=target] run data merge block -221 5 570 {showboundingbox:0b}
execute if entity @e[name=Global,scores={pregame=100},tag=snipers] run fill -221 20 570 -213 30 578 air

#wait messages
execute if entity @e[name=Global,scores={pregame=1}] as @a[team=!spectator] at @s run playsound minecraft:entity.player.levelup master @s ~ ~ ~ 1 1
execute if entity @e[name=Global,scores={pregame=61}] run tag @e[name=Global] add textTimer
execute if entity @e[name=Global,tag=textTimer] run function skyscapers:credit_wait_sequence

#announce gamemode
execute if entity @e[name=Global,scores={pregame=139}] run title @a[team=!spectator] times 0 100 40
execute if entity @e[name=Global,scores={pregame=140}] run title @a[team=!spectator] title {"text":"Gamemode","underlined":true,"color":"dark_gray"}
execute if entity @e[name=Global,scores={pregame=140}] as @a[team=!spectator] at @s run playsound minecraft:block.note_block.pling master @s ~ ~ ~ 1 0
execute if entity @e[name=Global,scores={pregame=160},tag=classic] run title @a[team=!spectator] subtitle {"text":"Classic","color":"dark_green"}
execute if entity @e[name=Global,scores={pregame=160},tag=target] run title @a[team=!spectator] subtitle {"text":"Target Shootout","color":"dark_red"}
execute if entity @e[name=Global,scores={pregame=160},tag=snipers] run title @a[team=!spectator] subtitle {"text":"Sky Snipers","color":"dark_aqua"}
execute if entity @e[name=Global,scores={pregame=160}] as @a[team=!spectator] at @s run playsound minecraft:block.note_block.pling master @s ~ ~ ~ 1 1

#tp and clear effects
execute if entity @e[name=Global,scores={pregame=179}] run tp @a[team=!spectator] -217 32 574
execute if entity @e[name=Global,scores={pregame=180}] as @a[team=!spectator] at @s run playsound minecraft:block.note_block.pling master @s ~ ~ ~ 1 2
execute if entity @e[name=Global,scores={pregame=179}] as @a[tag=!blind] run effect give @s night_vision 100000 255 true
execute if entity @e[name=Global,scores={pregame=180},tag=!snipers] run effect clear @a blindness
execute if entity @e[name=Global,scores={pregame=180},tag=!snipers] run effect clear @a slowness
execute if entity @e[name=Global,scores={pregame=180},tag=!snipers] run effect clear @a jump_boost

#switch gamestate (2 = classic, 3 = target, 4 = snipers)
execute if entity @e[name=Global,scores={pregame=181},tag=classic] run scoreboard players set @e[name=Global] gameState 2
execute if entity @e[name=Global,scores={pregame=181},tag=target] run scoreboard players set @e[name=Global] gameState 3
execute if entity @e[name=Global,scores={pregame=181},tag=snipers] run scoreboard players set @e[name=Global] gameState 4

#concluding stuff
execute if entity @e[name=Global,scores={pregame=180}] run gamemode spectator @a[team=spectator]
execute if entity @e[name=Global,scores={pregame=180}] run tp @a[team=spectator] -217 40 574

#test for leave
scoreboard players set @e[name=Global] scaperCheck 0
scoreboard players set @e[name=Global] seekerCheck 0
execute as @a[team=scapers] run scoreboard players add @e[name=Global] scaperCheck 1
execute as @a[team=seeker] run scoreboard players add @e[name=Global] seekerCheck 1
execute if entity @e[name=Global,scores={scaperCheck=0},tag=classic] run function skyscapers:scapers_left
execute if entity @e[name=Global,scores={seekerCheck=0},tag=classic] run function skyscapers:seeker_left