#deny players from grabbing powerups
execute as @e[tag=powerup_stand] at @s as @a[tag=!delay_text,tag=has_powerup,distance=..3] run tag @s add reject_has
execute as @e[tag=powerup_stand] at @s as @a[tag=!delay_text,tag=applied_powerup,distance=..3] run tag @s add reject_applied
execute as @e[tag=powerup_stand] at @s as @a[tag=!delay_text,tag=!has_powerup,tag=!applied_powerup,tag=!immunity,team=scapers,distance=..3] run tag @s add reject_check

#assign powerups to players
execute as @e[tag=powerup_stand] at @s as @a[tag=reject_check,distance=..3,sort=nearest,limit=1] unless entity @a[tag=has_powerup] unless entity @a[tag=applied_powerup] run tag @s add grab_powerup
execute as @a[tag=reject_check,tag=grab_powerup] run tag @s remove reject_check
execute as @a[tag=grab_powerup] at @s if entity @e[tag=powerup_stand,distance=..3,sort=nearest,limit=1,tag=blindness] run tag @s add blindness
execute as @a[tag=grab_powerup] at @s if entity @e[tag=powerup_stand,distance=..3,sort=nearest,limit=1,tag=boost] run tag @s add boost
execute as @a[tag=grab_powerup] at @s if entity @e[tag=powerup_stand,distance=..3,sort=nearest,limit=1,tag=destroy_wand] run tag @s add destroy_wand
execute as @a[tag=grab_powerup] at @s if entity @e[tag=powerup_stand,distance=..3,sort=nearest,limit=1,tag=absorption] run tag @s add absorption
execute as @a[tag=grab_powerup] at @s if entity @e[tag=powerup_stand,distance=..3,sort=nearest,limit=1,tag=invulnerability] run tag @s add invulnerability
execute as @a[tag=grab_powerup] at @s if entity @e[tag=powerup_stand,distance=..3,sort=nearest,limit=1,tag=one_shot] run tag @s add one_shot
execute as @a[tag=grab_powerup] at @s if entity @e[tag=powerup_stand,distance=..3,sort=nearest,limit=1,tag=nausea] run tag @s add nausea
execute as @a[tag=grab_powerup] at @s if entity @e[tag=powerup_stand,distance=..3,sort=nearest,limit=1,tag=regeneration] run tag @s add regeneration
execute as @a[tag=grab_powerup] at @s if entity @e[tag=powerup_stand,distance=..3,sort=nearest,limit=1,tag=no_cooldown] run tag @s add no_cooldown

#deny misc
execute if entity @a[tag=reject_has] as @a[tag=reject_has] run tag @s add delay_text
execute if entity @a[tag=reject_has] as @a[tag=reject_applied] run tag @s add delay_text
execute if entity @a[tag=reject_has] as @a[tag=reject_check] run tag @s add delay_text
execute if entity @a[tag=reject_has] as @a[tag=reject_has] run title @s actionbar ["",{"text":"[ ! ]:","bold":true,"color":"dark_red"},{"text":" Cannot grab powerups with one active!","color":"gold"}]
execute if entity @a[tag=reject_applied] as @a[tag=reject_applied] run title @s actionbar ["",{"text":"[ ! ]:","bold":true,"color":"dark_red"},{"text":" Cannot grab powerups with one active!","color":"gold"}]
execute if entity @a[tag=reject_check] as @a[tag=reject_check] run title @s actionbar ["",{"text":"[ ! ]:","bold":true,"color":"dark_red"},{"text":" All other scapers have active powerups!","color":"gold"}]
execute if entity @a[tag=reject_has] as @a[tag=reject_has] at @s run playsound minecraft:entity.villager.no master @s ~ ~ ~ 1 1
execute if entity @a[tag=reject_applied] as @a[tag=reject_applied] at @s run playsound minecraft:entity.villager.no master @s ~ ~ ~ 1 1
execute if entity @a[tag=reject_check] as @a[tag=reject_check] at @s run playsound minecraft:entity.villager.no master @s ~ ~ ~ 1 1
execute if entity @a[tag=reject_has] as @a[tag=reject_has] run tag @s remove reject_has
execute if entity @a[tag=reject_applied] as @a[tag=reject_applied] run tag @s remove reject_applied
execute if entity @a[tag=reject_check] as @a[tag=reject_check] run tag @s remove reject_check

#delay text scoreboard
tag @a[tag=grab_powerup,tag=!delay_text] add delay_text
execute as @a[tag=delay_text] run scoreboard players add @s delay 1
execute as @a[tag=delay_text,scores={delay=60}] run tag @s remove delay_text
execute as @a[scores={delay=60}] run scoreboard players reset @s delay

#kill armor stand
execute as @e[tag=powerup_stand] at @s if entity @a[team=scapers,distance=..3,sort=nearest,limit=1,tag=grab_powerup] run tag @s add kill_stand
execute if entity @e[tag=kill_stand] as @e[tag=kill_stand] at @s run particle minecraft:explosion ~ ~ ~ 0 0 0 0 1 normal @a
execute if entity @e[tag=kill_stand] run kill @e[tag=kill_stand]
#execute as @e[tag=powerup_display] at @s unless entity @e[tag=powerup_stand,distance=..3] run kill @s

#misc
execute as @e[tag=grab_powerup] at @s run playsound minecraft:block.note_block.bit master @s ~ ~ ~ 1 1.5
scoreboard players add @a[tag=has_powerup] powerup_time 1
scoreboard players add @a[tag=applied_powerup] powerup_time 1
execute if entity @a[scores={powerup_time2=..220}] run scoreboard players remove @a[scores={powerup_time2=..220}] powerup_time2 1

#give status tag
execute as @e[tag=grab_powerup] run tag @s add has_powerup

#absorption
execute as @e[tag=grab_powerup,tag=absorption] run title @s actionbar ["",{"text":"[Powerup]:","bold":true,"color":"dark_purple"},{"text":" Absorption","bold":true,"color":"dark_aqua"},{"text":" activated!","color":"light_purple"}]
execute if entity @a[tag=absorption] run effect give @a[tag=absorption,scores={powerup_time=1}] absorption 10 2 true
execute if entity @a[tag=grab_powerup,tag=absorption] as @a[tag=grab_powerup,tag=absorption] run scoreboard players set @s powerup_time2 219
execute if entity @a[tag=absorption,scores={powerup_time=..200}] as @a[tag=absorption] run scoreboard players operation @s powerup_count = @s powerup_time2
execute if entity @a[tag=absorption,scores={powerup_time=..200}] as @a[tag=absorption] run scoreboard players operation @s powerup_count /= @e[name=Global] global_20
execute if entity @a[tag=absorption,scores={powerup_time=..200}] as @a[tag=absorption] run title @s title {"text":" "}
execute if entity @a[tag=absorption,scores={powerup_time=..200}] as @a[tag=absorption] run title @s subtitle ["",{"text":"[Absorption]: ","bold":true,"color":"dark_aqua"},{"score":{"name":"@s","objective":"powerup_count"},"color":"gold"}]
execute if entity @a[tag=absorption,scores={powerup_time=..200}] as @a[tag=absorption] at @s run particle dust 0.000 0.659 0.659 0.300 ^ ^1 ^4 1 1 1 0 5 normal @s
execute if entity @a[tag=absorption,scores={powerup_time=200}] as @a[tag=absorption,scores={powerup_time=200}] run title @s title {"text":" "}
execute if entity @a[tag=absorption,scores={powerup_time=200}] as @a[tag=absorption,scores={powerup_time=200}] run title @s subtitle {"text":" "}
execute if entity @a[tag=absorption,scores={powerup_time=200}] run tag @a[tag=absorption,scores={powerup_time=200}] add end_powerup
execute if entity @a[tag=absorption,tag=end_powerup] run tag @a[tag=absorption,tag=end_powerup] remove absorption

#blindness
execute as @e[tag=grab_powerup,tag=blindness] run title @s actionbar ["",{"text":"[Powerup]:","bold":true,"color":"dark_purple"},{"text":" Blindness","bold":true,"color":"dark_gray"},{"text":" activated!","color":"light_purple"}]
execute if entity @a[tag=grab_powerup,tag=blindness] run tag @a[team=scapers,tag=!grab_powerup,tag=!applied_powerup,tag=!has_powerup] add blinded
execute if entity @a[tag=grab_powerup,tag=blindness] run effect give @a[tag=blinded] blindness 6 255 true
execute if entity @a[tag=grab_powerup,tag=blindness] run scoreboard players set @a[tag=blinded] powerup_time 1
execute if entity @a[tag=grab_powerup,tag=blindness] run tag @a[tag=blinded] add applied_powerup
execute if entity @a[tag=grab_powerup,tag=blindness] run scoreboard players set @a[tag=blinded] powerup_time2 119
execute if entity @a[tag=blinded,scores={powerup_time=..100}] as @a[tag=blinded] run scoreboard players operation @s powerup_count = @s powerup_time2
execute if entity @a[tag=blinded,scores={powerup_time=..100}] as @a[tag=blinded] run scoreboard players operation @s powerup_count /= @e[name=Global] global_20
execute if entity @a[tag=blinded,scores={powerup_time=..100}] as @a[tag=blinded] run title @s title {"text":" "}
execute if entity @a[tag=blinded,scores={powerup_time=..100}] as @a[tag=blinded] run title @s subtitle ["",{"text":"[Blindness]: ","bold":true,"color":"white"},{"score":{"name":"@s","objective":"powerup_count"},"color":"gold"}]
execute if entity @a[tag=blindness,scores={powerup_time=..100}] as @a[tag=blinded] run title @a[tag=blindness] title {"text":" "}
execute if entity @a[tag=blindness,scores={powerup_time=..100}] as @a[tag=blinded,limit=1] run title @a[tag=blindness] subtitle ["",{"text":"[Blindness]: ","bold":true,"color":"dark_gray"},{"score":{"name":"@s","objective":"powerup_count"},"color":"gold"}]
execute if entity @a[tag=blinded,scores={powerup_time=..100}] as @a[tag=blinded] at @s run particle dust 0.000 0.0 0.0 0.300 ^ ^1 ^4 1 1 1 0 5 normal @s
execute if entity @a[tag=grab_powerup,tag=blindness] as @a[tag=blinded] at @s run playsound minecraft:entity.lightning_bolt.thunder master @s ~ ~ ~ 1 2
execute if entity @a[tag=blinded,scores={powerup_time=100}] run title @a[tag=blinded] title {"text":" "}
execute if entity @a[tag=blinded,scores={powerup_time=100}] run title @a[tag=blinded] subtitle {"text":" "}
execute if entity @a[tag=blindness,scores={powerup_time=100}] run title @a[tag=blindness] title {"text":" "}
execute if entity @a[tag=blindness,scores={powerup_time=100}] run title @a[tag=blindness] subtitle {"text":" "}
execute if entity @a[tag=blindness,scores={powerup_time=100}] run tag @a[tag=blindness,scores={powerup_time=100}] add end_powerup
execute if entity @a[tag=blinded,scores={powerup_time=100}] run tag @a[tag=blinded,scores={powerup_time=100}] add end_powerup
execute if entity @a[tag=blindness,tag=end_powerup] run tag @a[tag=blindness,tag=end_powerup] remove blindness
execute if entity @a[tag=blinded,tag=end_powerup] run tag @a[tag=blinded,tag=end_powerup] remove blinded

#boost
execute as @e[tag=grab_powerup,tag=boost] run title @s actionbar ["",{"text":"[Powerup]:","bold":true,"color":"dark_purple"},{"text":" Boost","bold":true,"color":"#FF0023"},{"text":" activated!","color":"light_purple"}]
execute if entity @a[tag=grab_powerup,tag=boost] run scoreboard players set @a[tag=boost] powerup_time2 219
execute if entity @a[tag=boost,scores={powerup_time=..200}] as @a[tag=boost] run scoreboard players operation @s powerup_count = @s powerup_time2
execute if entity @a[tag=boost,scores={powerup_time=..200}] as @a[tag=boost] run scoreboard players operation @s powerup_count /= @e[name=Global] global_20
execute if entity @a[tag=boost,scores={powerup_time=..200}] as @a[tag=boost] run title @s title {"text":" "}
execute if entity @a[tag=boost,scores={powerup_time=..200}] as @a[tag=boost] run title @s subtitle ["",{"text":"[Boost]: ","bold":true,"color":"#FF0023"},{"score":{"name":"@s","objective":"powerup_count"},"color":"gold"}]
execute if entity @a[tag=boost,scores={powerup_time=..200}] as @a[tag=boost] at @s run particle dust 1.000 0.000 0.000 0.300 ^ ^1 ^4 1 1 1 0 5 normal @s
execute if entity @a[tag=boost,scores={powerup_time=200}] run title @a[tag=boost] title {"text":" "}
execute if entity @a[tag=boost,scores={powerup_time=200}] run title @a[tag=boost] subtitle {"text":" "}
execute if entity @a[tag=boost,scores={powerup_time=200}] run tag @a[tag=boost,scores={powerup_time=200}] add end_powerup
execute if entity @a[tag=boost,scores={powerup_time=200}] run tag @a[tag=boost,scores={powerup_time=200}] remove boost
execute if entity @a[tag=boost,tag=end_powerup] run tag @a[tag=boost,tag=end_powerup] remove boost

#destroy_wand
execute as @e[tag=grab_powerup,tag=destroy_wand] run title @s actionbar ["",{"text":"[Powerup]:","bold":true,"color":"dark_purple"},{"text":" Destroy Wand","bold":true,"color":"dark_purple"},{"text":" activated!","color":"light_purple"}]
execute if entity @a[tag=grab_powerup,tag=destroy_wand] run tag @r[team=scapers,tag=!grab_powerup,tag=!applied_powerup,tag=!has_powerup] add destroy_powerup
execute if entity @a[tag=grab_powerup,tag=destroy_wand] run tag @a[tag=destroy_powerup] add applied_powerup
execute if entity @a[tag=grab_powerup,tag=destroy_wand] run scoreboard players set @a[tag=destroy_powerup] powerup_time 1
execute if entity @a[tag=grab_powerup,tag=destroy_wand] run scoreboard players set @a[tag=destroy_powerup] powerup_time2 219
execute if entity @a[tag=destroy_powerup,scores={powerup_time=..200}] as @a[tag=destroy_powerup] run scoreboard players operation @s powerup_count = @s powerup_time2
execute if entity @a[tag=destroy_powerup,scores={powerup_time=..200}] as @a[tag=destroy_powerup] run scoreboard players operation @s powerup_count /= @e[name=Global] global_20
execute if entity @a[tag=destroy_powerup,scores={powerup_time=..200}] as @a[tag=destroy_powerup] run title @s title {"text":" "}
execute if entity @a[tag=destroy_powerup,scores={powerup_time=..200}] as @a[tag=destroy_powerup] run title @s subtitle ["",{"text":"[Wand Destroyed]: ","bold":true,"color":"dark_purple"},{"score":{"name":"@s","objective":"powerup_count"},"color":"gold"}]
execute if entity @a[tag=destroy_powerup,scores={powerup_time=..200}] as @a[tag=destroy_powerup] run title @a[tag=destroy_wand] title {"text":" "}
execute if entity @a[tag=destroy_powerup,scores={powerup_time=..200}] as @a[tag=destroy_powerup] run title @a[tag=destroy_wand] subtitle ["",{"text":"[Wand Destroyed]: ","bold":true,"color":"dark_purple"},{"selector":"@s"}]
execute if entity @a[tag=destroy_powerup,scores={powerup_time=..200}] as @a[tag=destroy_powerup] at @s run particle dust 0.655 0.000 0.655 0.300 ^ ^1 ^4 1 1 1 0 5 normal @s
execute if entity @a[tag=grab_powerup,tag=destroy_wand] as @a[tag=destroy_powerup] at @s run playsound minecraft:item.shield.break master @s ~ ~ ~ 1 1
execute if entity @a[tag=destroy_powerup,scores={powerup_time=200}] run title @a[tag=destroy_powerup] title {"text":" "}
execute if entity @a[tag=destroy_powerup,scores={powerup_time=200}] run title @a[tag=destroy_powerup] subtitle {"text":" "}
execute if entity @a[tag=destroy_powerup,scores={powerup_time=200}] run title @a[tag=destroy_wand] title {"text":" "}
execute if entity @a[tag=destroy_powerup,scores={powerup_time=200}] run title @a[tag=destroy_wand] subtitle {"text":" "}
execute if entity @a[tag=destroy_wand,scores={powerup_time=200}] run tag @a[tag=destroy_wand,scores={powerup_time=200}] add end_powerup
execute if entity @a[tag=destroy_powerup,scores={powerup_time=200}] run tag @a[tag=destroy_powerup,scores={powerup_time=200}] add end_powerup
# ----------- Return Wands ----------------------
execute if entity @a[tag=destroy_powerup,tag=end_powerup] as @a[tag=destroy_powerup,tag=end_powerup] if entity @s[tag=stick_wand] run replaceitem entity @s hotbar.4 minecraft:purple_carpet{display:{Name:'{"text":"Broken Stick","color":"#381C01","bold":true}',Lore:['{"text":"Right-click to use!","color":"red","italic":true}']}}
execute if entity @a[tag=destroy_powerup,tag=end_powerup] as @a[tag=destroy_powerup,tag=end_powerup] if entity @s[tag=emerald_wand] run replaceitem entity @s hotbar.4 minecraft:pink_carpet{display:{Name:'{"text":"Emerald Staff","color":"dark_green","bold":true}',Lore:['{"text":"Right-click to use!","color":"red","italic":true}']}}
execute if entity @a[tag=destroy_powerup,tag=end_powerup] as @a[tag=destroy_powerup,tag=end_powerup] if entity @s[tag=toy_wand] run replaceitem entity @s hotbar.4 minecraft:yellow_carpet{display:{Name:'{"text":"Banana Blaster","color":"yellow","bold":true}',Lore:['{"text":"Right-click to use!","color":"red","italic":true}']}}
execute if entity @a[tag=destroy_powerup,tag=end_powerup] as @a[tag=destroy_powerup,tag=end_powerup] if entity @s[tag=magic_wand] run replaceitem entity @s hotbar.4 minecraft:magenta_carpet{display:{Name:'{"text":"Magic Wand","color":"white","bold":true}',Lore:['{"text":"Right-click to use!","color":"red","italic":true}']}}
execute if entity @a[tag=destroy_powerup,tag=end_powerup] as @a[tag=destroy_powerup,tag=end_powerup] if entity @s[tag=book_wand] run replaceitem entity @s hotbar.4 minecraft:orange_carpet{display:{Name:'{"text":"Book of Spells","color":"dark_gray","bold":true}',Lore:['{"text":"Right-click to use!","color":"red","italic":true}']}}
# -----------------------------------------------
execute if entity @a[tag=destroy_powerup,scores={powerup_time=200}] run tag @a[tag=destroy_powerup,scores={powerup_time=200}] remove destroy_powerup
execute if entity @a[tag=destroy_wand,tag=end_powerup] run tag @a[tag=destroy_wand,tag=end_powerup] remove destroy_wand

#invulnerability
execute as @e[tag=grab_powerup,tag=invulnerability] run title @s actionbar ["",{"text":"[Powerup]:","bold":true,"color":"dark_purple"},{"text":" Invulnerability","bold":true,"color":"dark_gray"},{"text":" activated!","color":"light_purple"}]
execute if entity @a[tag=invulnerability] run effect give @a[tag=invulnerability,scores={powerup_time=1}] resistance 10 255 true
execute if entity @a[tag=grab_powerup,tag=invulnerability] as @a[tag=grab_powerup,tag=invulnerability] run scoreboard players set @s powerup_time2 219
execute if entity @a[tag=invulnerability,scores={powerup_time=..200}] as @a[tag=invulnerability] run scoreboard players operation @s powerup_count = @s powerup_time2
execute if entity @a[tag=invulnerability,scores={powerup_time=..200}] as @a[tag=invulnerability] run scoreboard players operation @s powerup_count /= @e[name=Global] global_20
execute if entity @a[tag=invulnerability,scores={powerup_time=..200}] as @a[tag=invulnerability] run title @s title {"text":" "}
execute if entity @a[tag=invulnerability,scores={powerup_time=..200}] as @a[tag=invulnerability] run title @s subtitle ["",{"text":"[Invulnerability]: ","bold":true,"color":"dark_gray"},{"score":{"name":"@s","objective":"powerup_count"},"color":"gold"}]
execute if entity @a[tag=invulnerability,scores={powerup_time=..200}] as @a[tag=invulnerability] at @s run particle dust 0.400 0.400 0.400 0.300 ^ ^1 ^4 1 1 1 0 5 normal @s
execute if entity @a[tag=invulnerability,scores={powerup_time=200}] as @a[tag=invulnerability,scores={powerup_time=200}] run title @s title {"text":" "}
execute if entity @a[tag=invulnerability,scores={powerup_time=200}] as @a[tag=invulnerability,scores={powerup_time=200}] run title @s subtitle {"text":" "}
execute if entity @a[tag=invulnerability,scores={powerup_time=200}] run tag @a[tag=invulnerability,scores={powerup_time=200}] add end_powerup
execute if entity @a[tag=invulnerability,tag=end_powerup] run tag @a[tag=invulnerability,tag=end_powerup] remove invulnerability

#nausea
execute as @e[tag=grab_powerup,tag=nausea] run title @s actionbar ["",{"text":"[Powerup]:","bold":true,"color":"dark_purple"},{"text":" Nausea","bold":true,"color":"dark_green"},{"text":" activated!","color":"light_purple"}]
execute if entity @a[tag=grab_powerup,tag=nausea] run tag @r[team=scapers,tag=!grab_powerup,tag=!applied_powerup,tag=!has_powerup] add nauseated
execute if entity @a[tag=grab_powerup,tag=nausea] run effect give @a[tag=nauseated] nausea 12 10 true
execute if entity @a[tag=grab_powerup,tag=nausea] run tag @a[tag=nauseated] add applied_powerup
execute if entity @a[tag=grab_powerup,tag=nausea] run scoreboard players set @a[tag=nauseated] powerup_time 1
execute if entity @a[tag=grab_powerup,tag=nausea] run scoreboard players set @a[tag=nauseated] powerup_time2 219
execute if entity @a[tag=nauseated,scores={powerup_time=..200}] as @a[tag=nauseated] run scoreboard players operation @s powerup_count = @s powerup_time2
execute if entity @a[tag=nauseated,scores={powerup_time=..200}] as @a[tag=nauseated] run scoreboard players operation @s powerup_count /= @e[name=Global] global_20
execute if entity @a[tag=nauseated,scores={powerup_time=..200}] as @a[tag=nauseated] run title @s title {"text":" "}
execute if entity @a[tag=nauseated,scores={powerup_time=..200}] as @a[tag=nauseated] run title @s subtitle ["",{"text":"[Nausea]: ","bold":true,"color":"dark_green"},{"score":{"name":"@s","objective":"powerup_count"},"color":"gold"}]
execute if entity @a[tag=nauseated,scores={powerup_time=..200}] as @a[tag=nauseated] run title @a[tag=nausea] title {"text":" "}
execute if entity @a[tag=nauseated,scores={powerup_time=..200}] as @a[tag=nauseated] run title @a[tag=nausea] subtitle ["",{"text":"[Nausea]: ","bold":true,"color":"dark_green"},{"selector":"@s"}]
execute if entity @a[tag=nauseated,scores={powerup_time=..200}] as @a[tag=nauseated] at @s run particle dust 0.000 0.659 0.004 0.300 ^ ^1 ^4 1 1 1 0 5 normal @s
execute if entity @a[tag=grab_powerup,tag=nausea] as @a[tag=nauseated] at @s run playsound minecraft:entity.player.burp master @s ~ ~ ~ 1 1
execute if entity @a[tag=nauseated,scores={powerup_time=200}] run title @a[tag=nauseated] title {"text":" "}
execute if entity @a[tag=nauseated,scores={powerup_time=200}] run title @a[tag=nauseated] subtitle {"text":" "}
execute if entity @a[tag=nauseated,scores={powerup_time=200}] run title @a[tag=nausea] title {"text":" "}
execute if entity @a[tag=nauseated,scores={powerup_time=200}] run title @a[tag=nausea] subtitle {"text":" "}
execute if entity @a[tag=nausea,scores={powerup_time=200}] run tag @a[tag=nausea,scores={powerup_time=200}] add end_powerup
execute if entity @a[tag=nauseated,scores={powerup_time=200}] run tag @a[tag=nauseated,scores={powerup_time=200}] add end_powerup
execute if entity @a[tag=nausea,tag=end_powerup] run tag @a[tag=nausea,tag=end_powerup] remove nausea
execute if entity @a[tag=nauseated,tag=end_powerup] run tag @a[tag=nauseated,tag=end_powerup] remove nauseated

#no_cooldown
execute as @e[tag=grab_powerup,tag=no_cooldown] run title @s actionbar ["",{"text":"[Powerup]:","bold":true,"color":"dark_purple"},{"text":" No-Cooldown","bold":true,"color":"dark_red"},{"text":" activated!","color":"light_purple"}]
execute if entity @a[tag=grab_powerup,tag=no_cooldown] as @a[tag=grab_powerup,tag=no_cooldown] run scoreboard players set @s powerup_time2 119
execute if entity @a[tag=no_cooldown,scores={powerup_time=..100}] as @a[tag=no_cooldown] run scoreboard players operation @s powerup_count = @s powerup_time2
execute if entity @a[tag=no_cooldown,scores={powerup_time=..100}] as @a[tag=no_cooldown] run scoreboard players operation @s powerup_count /= @e[name=Global] global_20
execute if entity @a[tag=no_cooldown,scores={powerup_count=1..}] as @a[tag=no_cooldown] run title @s title {"text":" "}
execute if entity @a[tag=no_cooldown,scores={powerup_count=1..}] as @a[tag=no_cooldown] run title @s subtitle ["",{"text":"[No-Cooldown]: ","bold":true,"color":"dark_red"},{"score":{"name":"@s","objective":"powerup_count"},"color":"gold"}]
execute if entity @a[tag=no_cooldown,scores={powerup_time=100}] as @a[tag=no_cooldown] at @s run particle dust 1.000 0.000 0.000 0.300 ^ ^1 ^4 1 1 1 0 5 normal @s
execute if entity @a[tag=no_cooldown,scores={powerup_time=100}] run title @a[tag=no_cooldown] title {"text":" "}
execute if entity @a[tag=no_cooldown,scores={powerup_time=100}] run title @a[tag=no_cooldown] subtitle {"text":" "}
execute if entity @a[tag=no_cooldown,scores={powerup_time=100}] run tag @a[tag=no_cooldown,scores={powerup_time=100}] add end_powerup
execute if entity @a[tag=no_cooldown,tag=end_powerup] run tag @a[tag=no_cooldown,tag=end_powerup] remove no_cooldown

#one_shot
execute as @e[tag=grab_powerup,tag=one_shot] run title @s actionbar ["",{"text":"[Powerup]:","bold":true,"color":"dark_purple"},{"text":" One-Shot","bold":true,"color":"gold"},{"text":" activated!","color":"light_purple"}]
execute if entity @a[tag=grab_powerup,tag=one_shot] as @a[tag=grab_powerup,tag=one_shot] run scoreboard players set @s powerup_time2 219
execute if entity @a[tag=one_shot,scores={powerup_time=..200}] as @a[tag=one_shot] run scoreboard players operation @s powerup_count = @s powerup_time2
execute if entity @a[tag=one_shot,scores={powerup_time=..200}] as @a[tag=one_shot] run scoreboard players operation @s powerup_count /= @e[name=Global] global_20
execute if entity @a[tag=one_shot,scores={powerup_time=..200}] as @a[tag=one_shot] run title @s title {"text":" "}
execute if entity @a[tag=one_shot,scores={powerup_time=..200}] as @a[tag=one_shot] run title @s subtitle ["",{"text":"[One-Shot]: ","bold":true,"color":"gold"},{"score":{"name":"@s","objective":"powerup_count"},"color":"gold"}]
execute if entity @a[tag=one_shot,scores={powerup_time=..200}] as @a[tag=one_shot] at @s run particle dust 1.000 1.000 0.000 0.300 ^ ^1 ^4 1 1 1 0 5 normal @s
execute if entity @a[tag=one_shot,scores={powerup_time=200}] run tag @a[tag=one_shot,scores={powerup_time=200}] add end_powerup
execute if entity @a[tag=one_shot,tag=end_powerup] run title @a[tag=one_shot,tag=end_powerup] title {"text":" "}
execute if entity @a[tag=one_shot,tag=end_powerup] run title @a[tag=one_shot,tag=end_powerup] subtitle {"text":" "}
execute if entity @a[tag=one_shot,tag=end_powerup] run tag @a[tag=one_shot,tag=end_powerup] remove one_shot

#regeneration
execute as @e[tag=grab_powerup,tag=regeneration] run title @s actionbar ["",{"text":"[Powerup]:","bold":true,"color":"dark_purple"},{"text":" Regeneration","bold":true,"color":"#FF0085"},{"text":" activated!","color":"light_purple"}]
execute if entity @a[tag=regeneration] run effect give @a[tag=regeneration,scores={powerup_time=1}] regeneration 11 1 true
execute if entity @a[tag=grab_powerup,tag=regeneration] as @a[tag=grab_powerup,tag=regeneration] run scoreboard players set @s powerup_time2 219
execute if entity @a[tag=regeneration,scores={powerup_time=..200}] as @a[tag=regeneration] run scoreboard players operation @s powerup_count = @s powerup_time2
execute if entity @a[tag=regeneration,scores={powerup_time=..200}] as @a[tag=regeneration] run scoreboard players operation @s powerup_count /= @e[name=Global] global_20
execute if entity @a[tag=regeneration,scores={powerup_time=..200}] as @a[tag=regeneration] run title @s title {"text":" "}
execute if entity @a[tag=regeneration,scores={powerup_time=..200}] as @a[tag=regeneration] run title @s subtitle ["",{"text":"[Regeneration]: ","bold":true,"color":"#FF0085"},{"score":{"name":"@s","objective":"powerup_count"},"color":"gold"}]
execute if entity @a[tag=regeneration,scores={powerup_time=..200}] as @a[tag=regeneration] at @s run particle dust 0.984 0.000 0.514 0.300 ^ ^1 ^4 1 1 1 0 5 normal @s
execute if entity @a[tag=regeneration,scores={powerup_time=200}] as @a[tag=regeneration,scores={powerup_time=200}] run title @s title {"text":" "}
execute if entity @a[tag=regeneration,scores={powerup_time=200}] as @a[tag=regeneration,scores={powerup_time=200}] run title @s subtitle {"text":" "}
execute if entity @a[tag=regeneration,scores={powerup_time=200}] run tag @a[tag=regeneration,scores={powerup_time=200}] add end_powerup
execute if entity @a[tag=regeneration,tag=end_powerup] run tag @a[tag=regeneration,tag=end_powerup] remove regeneration

#remove tag
execute if entity @a[tag=grab_powerup] as @a[tag=grab_powerup] run tag @s remove grab_powerup
execute if entity @a[tag=end_powerup,tag=has_powerup] as @a[tag=end_powerup,tag=has_powerup] run tag @s remove has_powerup
execute if entity @a[tag=end_powerup] as @a[tag=end_powerup] run scoreboard players reset @s powerup_time
execute if entity @a[tag=end_powerup] as @a[tag=end_powerup] run scoreboard players reset @s powerup_time2
execute if entity @a[tag=end_powerup] as @a[tag=end_powerup] run scoreboard players reset @s powerup_count
execute if entity @a[tag=applied_powerup,tag=end_powerup] as @a[tag=applied_powerup,tag=end_powerup] run tag @s remove applied_powerup
execute if entity @a[tag=end_powerup] as @a[tag=end_powerup] run tag @s remove end_powerup