scoreboard players reset @s deaths
execute if entity @s[scores={lives=1..}] run tag @s add immune
execute positioned as @e[tag=teleport,sort=random,limit=1] run spawnpoint @s ~ ~ ~
scoreboard players remove @s lives 1
effect clear @s glowing
effect clear @s wither
execute if entity @s[scores={lives=2..}] run title @s title ["",{"score":{"name":"@s","objective":"lives"},"bold":true,"color":"gold"},{"text":" lives left!","color":"dark_red"}]
execute if entity @s[scores={lives=1}] run title @s title ["",{"score":{"name":"@s","objective":"lives"},"bold":true,"color":"gold"},{"text":" life left!","color":"dark_red"}]
execute at @s if entity @s[scores={lives=2..}] run playsound minecraft:block.anvil.land master @s ~ ~ ~ 0.5 2
execute at @s if entity @s[scores={lives=1}] run playsound minecraft:entity.lightning_bolt.thunder master @s ~ ~ ~ 1 2
execute if entity @s[scores={lives=0}] run tellraw @a ["",{"text":"\u2716","color":"dark_red"},{"text":" ","color":"gold"},{"selector":"@s","bold":true,"color":"aqua"},{"text":" has been eliminated!","color":"gold"}]
execute if entity @s[scores={lives=2..}] run tellraw @a ["",{"selector":"@s","bold":true,"color":"aqua"},{"text":" has been knocked down, and now has ","color":"gold"},{"score":{"name":"@s","objective":"lives"},"bold":true},{"text":" lives remaining!","color":"gold"}]
execute if entity @s[scores={lives=1}] run tellraw @a ["",{"text":"\u2605 ","color":"gold"},{"selector":"@s","bold":true,"color":"aqua"},{"text":" is down to their final life! Be careful!","color":"gold"}]
title @s title {"text":" "}
title @s subtitle {"text":" "}
title @s actionbar {"text":" "}
attribute @s minecraft:generic.max_health base set 18

execute if entity @s[tag=grab_powerup] run tag @s remove grab_powerup
execute if entity @s[tag=has_powerup] run tag @s remove has_powerup
execute if entity @s[tag=applied_powerup] run tag @s remove applied_powerup
execute if entity @s[scores={powerup_time=0..}] run scoreboard players reset @s powerup_time
execute if entity @s[scores={powerup_time2=0..}] run scoreboard players reset @s powerup_time2
execute if entity @s[scores={powerup_count=0..}] run scoreboard players reset @s powerup_count
execute if entity @s[tag=end_powerup] run tag @s remove end_powerup
execute if entity @s[tag=blindness] run effect clear @s blindness
execute if entity @s[tag=blindness] run tag @s remove blindness
execute if entity @s[tag=blinded] run tag @s remove blinded
execute if entity @s[tag=boost] run tag @s remove boost
execute if entity @s[tag=destroy_wand] run tag @s remove destroy_wand
execute if entity @s[tag=destroy_powerup] run tag @s remove destroy_powerup
execute if entity @s[tag=absorption] run effect clear @s absorption
execute if entity @s[tag=absorption] run tag @s remove absorption
execute if entity @s[tag=invulnerability] run effect clear @s resistance
execute if entity @s[tag=invulnerability] run tag @s remove invulnerability
execute if entity @s[tag=one_shot] run tag @s remove one_shot
execute if entity @s[tag=no_cooldown] run tag @s remove no_cooldown
execute if entity @s[tag=nausea] run effect clear @s nausea
execute if entity @s[tag=nausea] run tag @s remove nausea
execute if entity @s[tag=nauseated] run tag @s remove nauseated
execute if entity @s[tag=regeneration] run effect clear @s regeneration
execute if entity @s[tag=regeneration] run tag @s remove regeneration

execute if entity @s[scores={lives=..0}] run team join spectator @s
execute if entity @s[scores={lives=..0}] run tag @s add dead_scaper
execute if entity @s[scores={lives=..0}] run tp @s -217 32 574
execute at @s if entity @s[scores={lives=0}] run playsound minecraft:block.beacon.deactivate master @a ~ ~ ~ 1 2
execute if entity @s[scores={lives=..0}] run gamemode spectator @s
execute if entity @s[scores={lives=..0}] run scoreboard players reset @s fireworkTime
execute if entity @s[scores={lives=..0},tag=poison] run tag @s remove poison
execute if entity @s[scores={lives=..0}] run clear @s
execute if entity @s[scores={lives=..0}] run scoreboard players reset @s lives

