#send back to lobby if necessary
execute as @a[team=!spectator] run scoreboard players add @e[name=Global] total_players 1
execute if entity @e[name=Global,scores={total_players=1,gameState=1..}] run tag @e[name=Global] add abandoned
execute if entity @e[name=Global,tag=abandoned] run function skyscapers:gamemodes/reset
execute if entity @e[name=Global,tag=abandoned] if entity @e[tag=powerup_stand] run kill @e[tag=powerup_stand]
execute if entity @e[name=Global,tag=abandoned] run title @s title {"text":" "}
execute if entity @e[name=Global,tag=abandoned] run title @s subtitle {"text":" "}
execute if entity @e[name=Global,tag=abandoned] run title @s actionbar {"text":" "}
execute if entity @e[name=Global,tag=abandoned] run tag @e[name=Global] remove abandoned
scoreboard players set @e[name=Global] total_players 0

#general reset
scoreboard players reset @s
scoreboard players set @s join 2
scoreboard players set @s sneak 0
scoreboard players set @s fly 0
effect clear @s
title @s title {"text":" "}
title @s subtitle {"text":" "}
title @s actionbar {"text":" "}
tp @s -258 86 583 -82 -31
clear @s orange_carpet
clear @s magenta_carpet
clear @s pink_carpet
clear @s purple_carpet
clear @s yellow_carpet
execute if entity @e[name=Global,scores={gameState=1..}] run clear @s carrot_on_a_stick
execute if entity @e[name=Global,scores={gameState=0}] run replaceitem entity @s weapon.offhand carrot_on_a_stick{display:{Name:'{"text":" ","color":"black","bold":true}'}}
execute if entity @s[tag=!laugh_hat,tag=!cry_hat,tag=!sleep_hat,tag=!tv_hat,tag=!globe_hat] run tag @s add no_cosmetics
execute if entity @s[tag=!particle_black,tag=!particle_green,tag=!particle_pink,tag=!particle_yellow,tag=!particle_white] run tag @s add no_cosmetics
#add particle clear here
execute as @s run function skyscapers:lobby/display/hats/_reset
execute as @s run function skyscapers:particles/_reset
tag @s[tag=!first_join] add stick_wand
gamemode adventure @s
attribute @s minecraft:generic.max_health base set 18
attribute @s minecraft:generic.attack_damage base set -1
tag @s[tag=p] remove p
tag @s[tag=delay_text] remove delay_text
clear @s[tag=has_book] written_book
tag @s[tag=has_book] remove has_book
scoreboard players reset @e[tag=lobby_stand,sort=random,limit=2] random
execute if entity @e[name=Global,scores={gameState=0}] unless entity @s[tag=first_join] run tellraw @s ["",{"text":"\n\n"},{"text":"Welcome to ","color":"dark_aqua"},{"text":"Sky Scapers!","bold":true,"color":"aqua"},{"text":"\n\n","bold":true},{"text":"[ ! ]:","bold":true,"color":"dark_red"},{"text":" Make sure to check out the tutorial cave\nto learn how to play!","italic":false,"color":"dark_aqua"}]
execute if entity @e[name=Global,scores={gameState=0}] if entity @s[tag=first_join,tag=!no_cosmetics] run tellraw @s ["",{"text":"\n\n"},{"text":"Welcome back to ","color":"dark_aqua"},{"text":"Sky Scapers!","bold":true,"color":"aqua"},{"text":"\n\n"},{"text":"[ ! ]:","bold":true,"color":"dark_red"},{"text":" Cosmetics ","color":"gold"},{"text":"reset","color":"red"}]
execute if entity @e[name=Global,scores={gameState=0}] if entity @s[tag=first_join,tag=no_cosmetics] run tellraw @s ["",{"text":"\n\n"},{"text":"Welcome back to ","color":"dark_aqua"},{"text":"Sky Scapers!","bold":true,"color":"aqua"}]
tag @s[tag=no_cosmetics] remove no_cosmetics
execute if entity @e[name=Global,scores={gameState=0}] run team join scapers @s[team=!scapers,team=!seeker,team=!spectator]
execute if entity @e[name=Global,scores={gameState=1..}] run team join spectator @s
execute if entity @e[name=Global,scores={gameState=1..}] if entity @s[team=spectator] run gamemode spectator @s
execute if entity @e[name=Global,scores={gameState=1..}] at @s run playsound minecraft:ui.toast.out master @p ~ ~ ~ 2 1
execute if entity @e[name=Global,scores={gameState=1..}] run tellraw @s ["",{"text":"[ ! ]:","bold":true,"color":"dark_red"},{"text":" A game is in progress. Please wait for it to finish!","color":"red"}]
execute if entity @e[name=Global,scores={gameState=0}] at @s run playsound minecraft:entity.player.levelup master @s ~ ~ ~ 1 1.1
execute if entity @e[name=Global,scores={gameState=1..}] at @s run playsound minecraft:ui.button.click master @s ~ ~ ~ 1 1
execute if entity @e[name=Global,scores={gameState=1..}] run effect give @s night_vision 100000 255 true
execute if entity @e[name=Global,scores={gameState=2..}] run tp @s @r[team=seeker]
execute if entity @e[name=Global,scores={gameState=1..}] run clear @s
tag @s remove joined
execute if entity @s[tag=alive] run tag @s remove alive
tag @s add first_join

#give teams if gameState=0
execute if entity @e[name=Global,scores={gameState=0}] run replaceitem entity @s inventory.14 minecraft:light_blue_stained_glass{display:{Name:'{"text":"Join Scapers","color":"aqua","bold":false}'}}
execute if entity @e[name=Global,scores={gameState=0}] run replaceitem entity @s inventory.15 red_stained_glass{display:{Name:'{"text":"Join Seekers","color":"dark_red","bold":false}'}}
execute if entity @e[name=Global,scores={gameState=0}] run replaceitem entity @s inventory.16 gray_stained_glass{display:{Name:'{"text":"Join Spectators","color":"dark_gray","bold":false}'}}
execute if entity @e[name=Global,scores={gameState=0}] as @s[team=scapers] run replaceitem entity @s inventory.14 minecraft:light_blue_wool{display:{Name:'[{"text":"\\u2714 ","color":"dark_green","bold":false},{"text":"Join Scapers","color":"aqua","bold":false}]'}}
execute if entity @e[name=Global,scores={gameState=0}] as @s[team=seeker] run replaceitem entity @s inventory.15 red_wool{display:{Name:'[{"text":"\\u2714 ","color":"dark_green","bold":false},{"text":"Join Seekers","color":"dark_red","bold":false}]'}}
execute if entity @e[name=Global,scores={gameState=0}] as @s[team=spectator] run replaceitem entity @s inventory.16 gray_wool{display:{Name:'[{"text":"\\u2714 ","color":"dark_green","bold":false},{"text":"Join Spectators","color":"gray","bold":false}]'}}

#give banners if gameState=0
execute if entity @e[name=Global,scores={gameState=0}] run replaceitem entity @s inventory.10 white_banner{BlockEntityTag:{Patterns:[{Color:15,Pattern:"ls"},{Color:15,Pattern:"bs"},{Color:15,Pattern:"ts"},{Color:0,Pattern:"bo"}]},HideFlags:63,display:{Name:'{"text":"Classic","color":"white","bold":false}'}}
execute if entity @e[name=Global,scores={gameState=0}] run replaceitem entity @s inventory.11 white_banner{BlockEntityTag:{Patterns:[{Color:15,Pattern:"ts"},{Color:15,Pattern:"cs"},{Color:0,Pattern:"bo"}]},HideFlags:63,display:{Name:'{"text":"Target Shootout","color":"white","bold":false}'}}
execute if entity @e[name=Global,scores={gameState=0}] run replaceitem entity @s inventory.12 white_banner{BlockEntityTag:{Patterns:[{Color:15,Pattern:"drs"},{Color:15,Pattern:"bs"},{Color:15,Pattern:"ts"},{Color:0,Pattern:"bo"}]},HideFlags:63,display:{Name:'{"text":"Sky Snipers","color":"white","bold":false}'}}
execute if entity @e[name=Global,scores={gameState=0}] if entity @e[name=Global,tag=classic] run replaceitem entity @s inventory.10 lime_banner{BlockEntityTag:{Patterns:[{Color:15,Pattern:"ls"},{Color:15,Pattern:"bs"},{Color:15,Pattern:"ts"},{Color:5,Pattern:"bo"}]},HideFlags:63,display:{Name:'[{"text":"\\u2714 ","color":"dark_green","bold":false},{"text":"Classic","color":"white","bold":false}]'}}
execute if entity @e[name=Global,scores={gameState=0}] if entity @e[name=Global,tag=target] run replaceitem entity @s inventory.11 lime_banner{BlockEntityTag:{Patterns:[{Color:15,Pattern:"ts"},{Color:15,Pattern:"cs"},{Color:5,Pattern:"bo"}]},HideFlags:63,display:{Name:'[{"text":"\\u2714 ","color":"dark_green","bold":false},{"text":"Target Shootout","color":"white","bold":false}]'}}
execute if entity @e[name=Global,scores={gameState=0}] if entity @e[name=Global,tag=snipers] run replaceitem entity @s inventory.12 lime_banner{BlockEntityTag:{Patterns:[{Color:15,Pattern:"drs"},{Color:15,Pattern:"bs"},{Color:15,Pattern:"ts"},{Color:5,Pattern:"bo"}]},HideFlags:63,display:{Name:'[{"text":"\\u2714 ","color":"dark_green","bold":false},{"text":"Sky Snipers","color":"white","bold":false}]'}}

#remove powerups
tag @s[tag=grab_powerup] remove grab_powerup
tag @s[tag=has_powerup] remove has_powerup
tag @s[tag=applied_powerup] remove applied_powerup
tag @s[tag=end_powerup] remove end_powerup
tag @s[tag=blindness] remove blindness
tag @s[tag=boost] remove boost
tag @s[tag=destroy_wand] remove destroy_wand
tag @s[tag=destroy_powerup] remove destroy_powerup
tag @s[tag=absorption] remove absorption
tag @s[tag=invulnerability] remove invulnerability
tag @s[tag=launch_pad] remove launch_pad
tag @s[tag=nausea] remove nausea
tag @s[tag=regeneration] remove regeneration
tag @s[tag=twister] remove twister
tag @s[tag=twister_seeker] remove twister_seeker
tag @s[tag=blinded] remove blinded
tag @s[tag=nauseated] remove nauseated
tag @s[tag=one_shot] remove one_shot
tag @s[tag=no_cooldown] remove no_cooldown

#ID System
scoreboard players operation @s ID = @e[name=Global] ID
scoreboard players operation @s ID_FINAL = @s ID
scoreboard players add @e[name=Global] ID 1

#misc
tp @e[type=armor_stand,tag=MCFilms] -269.474116 88.01558813 587.904494 -90 0
effect give @e[tag=snail_credit] invisibility 100000 255 true